=== debian/control ===
Source: ros-galactic-ros1-bridge
Section: misc
Priority: optional
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), python3-rospkg, ros-noetic-actionlib-msgs, ros-noetic-catkin, ros-noetic-common-msgs, ros-noetic-gazebo-msgs, ros-noetic-geometry-msgs, ros-noetic-nav-msgs, ros-noetic-rosbash, ros-noetic-roscpp, ros-noetic-roscpp-tutorials, ros-noetic-roslaunch, ros-noetic-rosmsg, ros-noetic-rospy-tutorials, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-stereo-msgs, ros-noetic-tf, ros-noetic-tf2-msgs, ros-noetic-trajectory-msgs, ros-noetic-visualization-msgs, pkg-config, python3-catkin-pkg-modules, python3-yaml, ros-galactic-actionlib-msgs, ros-galactic-ament-cmake, ros-galactic-ament-index-python, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-common, ros-galactic-builtin-interfaces, ros-galactic-demo-nodes-cpp, ros-galactic-diagnostic-msgs, ros-galactic-example-interfaces, ros-galactic-gazebo-msgs, ros-galactic-geometry-msgs, ros-galactic-launch, ros-galactic-launch-testing, ros-galactic-launch-testing-ament-cmake, ros-galactic-launch-testing-ros, ros-galactic-nav-msgs, ros-galactic-rclcpp, ros-galactic-rcutils, ros-galactic-rmw-implementation-cmake, ros-galactic-ros2run, ros-galactic-rosidl-cmake, ros-galactic-rosidl-parser, ros-galactic-sensor-msgs, ros-galactic-shape-msgs, ros-galactic-std-msgs, ros-galactic-std-srvs, ros-galactic-stereo-msgs, ros-galactic-tf2-msgs, ros-galactic-trajectory-msgs, ros-galactic-visualization-msgs, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-ros1-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3-rospkg, ros-noetic-actionlib-msgs, ros-noetic-catkin, ros-noetic-common-msgs, ros-noetic-gazebo-msgs, ros-noetic-geometry-msgs, ros-noetic-nav-msgs, ros-noetic-rosbash, ros-noetic-roscpp, ros-noetic-roscpp-tutorials, ros-noetic-roslaunch, ros-noetic-rosmsg, ros-noetic-rospy-tutorials, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-stereo-msgs, ros-noetic-tf, ros-noetic-tf2-msgs, ros-noetic-trajectory-msgs, ros-noetic-visualization-msgs, pkg-config, python3-yaml, ros-galactic-actionlib-msgs, ros-galactic-builtin-interfaces, ros-galactic-diagnostic-msgs, ros-galactic-example-interfaces, ros-galactic-gazebo-msgs, ros-galactic-geometry-msgs, ros-galactic-nav-msgs, ros-galactic-rclcpp, ros-galactic-rcutils, ros-galactic-sensor-msgs, ros-galactic-shape-msgs, ros-galactic-std-msgs, ros-galactic-std-srvs, ros-galactic-stereo-msgs, ros-galactic-tf2-msgs, ros-galactic-trajectory-msgs, ros-galactic-visualization-msgs, ros-galactic-ros-workspace
Description: A simple bridge between ROS 1 and ROS 2
